/**
 * file             : lkd.c
 * author           : Ingo A. Kubbilun <ingo@pyrillion.org>
 * license          : GNU GENERAL PUBLIC LICENSE 2 (or later)
 * 
 * description      : This is the linker delegate lkd, which
 *                    makes the compilation of the Linux kernel
 *                    using Intel(R) C/C++ Compiler for Linux
 *                    possible.
 *
 *                    See lkd(1) for details.
 *
 * revision history :
 * ------------------
 * 
 * version  date        comments
 * ---------------------------------------------------------------------
 * 0.1      04/01/2004  initial version, currently a dummy tool
 *                      - Ingo A. Kubbilun
**/

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/wait.h>

int main ( int argc, char *argv[] )
{
  int                     i=1,j=1;
  char                    szLD[64];

#ifdef _DEBUG
  fprintf(stdout,"\nLINKER CALL: ");
  for (int k=0;k<argc;k++) fprintf(stdout,"%s ",argv[k]);
  fprintf(stdout,"\n");
#endif

  strcpy(szLD,"ld");
  while (i<argc)
  {
    if (!memcmp(argv[i],"--linker=",9))
    {
      strcpy(szLD,argv[i]+9);
      i++;
    }
    else
    {
      argv[j++] = argv[i++];
    }
  }
  argv[j]=NULL;
  strcpy(argv[0],szLD);

  execvp(argv[0],&argv[0]);
  return 1;
}